#include "syncscheduler.hpp"
#include "DataInputWindow.hpp"
#include "MainWindow.hpp"
#include "SoftkeyWindow.hpp"
#include "syncscheduler.brh"

#define     LABEL_SOFTKEY1          ("I")
#define     LABEL_SOFTKEY3          ("I")
#define MENU_TOP_MARGIN    20
#define MENU_SIDE_MARGIN   20
#define MENU_SPACE         15
#define MENU_BOX_WIDTH     30
#define TEXTBOX_REVISING   6

DataInputWindow::DataInputWindow(SFXDateConstRef date) : SFRPlainWindow(SFRApplication::GetInstance(), syncscheduler::CalculateWindowPosition()), _date(date) static_throws
{
    //  soft keyo^
    SoftkeyWindowPtr softkey;

    SoftkeyWindow::Initialize(this);
    if (static_try()) {
        // `nho^
        static_throw(RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT,
        HANDLER_BEFORE, HANDLER_FUNCTION(OnRenderContent)));
        if (static_try()) {
            // L[nho^
            static_throw(RegisterHandler(SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
            if (static_try()) {
                //static_throw(RegisterHandler(static_cast<SFCEventEnum>(SoftkeyWindow::USEREVT_SOFTKEY), HANDLER_AFTER, HANDLER_FUNCTION(OnSoftkey)));
                if (static_try()) {
                    if ((softkey = SoftkeyWindow::GetInstance()) != null) {
                        static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_1, LABEL_SOFTKEY1));
                        if (static_try()) {
                            //static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_2, LABEL_SOFTKEY2));
                            if (static_try()) {
                                static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_3, LABEL_SOFTKEY3));
                                if (static_try()) {
                                    SetReference(softkey->Bind(this));
                                    _fontHeight = SFXGraphics::GetFontHeight(AEE_FONT_NORMAL);
                                    SFXRectangleConst screenRect(GetContentWorld());
                                    SFXRectangle rect(MENU_SIDE_MARGIN, MENU_TOP_MARGIN,
                                    screenRect.GetRight() - MENU_SIDE_MARGIN, _fontHeight);

                                    // x̐
                                    _labelDate = ::new SFRLabelControl(this, rect, date.Format("YYYY/MM/DD"));
                                    rect.AddY(_fontHeight + MENU_SPACE);
                                    rect.SetSize(MENU_BOX_WIDTH, _fontHeight + TEXTBOX_REVISING);

                                    // ԓ̓eLXgRg[̐
                                    _textHour = ::new SFREditboxControl(this, rect, SFXWideString::EmptyInstance());
                                    _textHour->SetInputMode(AEE_TM_NUMBERS);
                                    _textHour->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));
                                    rect.AddX(MENU_BOX_WIDTH);

                                    // x̐
                                    _labelHour = ::new SFRLabelControl(this, rect, "");
                                    rect.AddX(rect.GetWidth());

                                    // ̓eLXgRg[̐
                                    _textMinute = ::new SFREditboxControl(this, rect, SFXWideString::EmptyInstance());
                                    _textMinute->SetInputMode(AEE_TM_NUMBERS);
                                    _textMinute->RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));
                                    rect.AddX(MENU_BOX_WIDTH);

                                    // x̐
                                    _labelMinute = ::new SFRLabelControl(this, rect, "");
                                    rect.SetX(MENU_SIDE_MARGIN);
                                    rect.AddY(_fontHeight + MENU_SPACE + TEXTBOX_REVISING);
                                    rect.SetSize(screenRect.GetRight() - 2 * MENU_SIDE_MARGIN,
                                    screenRect.GetBottom() - 4 * MENU_SPACE
                                    - 3 * _fontHeight - MENU_TOP_MARGIN);

                                    // e̓eLXgRg[̐
                                    _textContent = ::new SFREditboxControl(this, rect, SFXWideString::EmptyInstance());
                                    _textContent-> RegisterHandler(SREVT_CONTROL, HANDLER_BEFORE, HANDLER_FUNCTION(OnEditboxHandler));

                                    // u͂v{^쐬
                                    SInt16 MENU_BUTTON_WIDTH1 = SFXGraphics::MeasureSingleText(AEE_FONT_NORMAL, "͂") +10;
                                    rect.Set(MENU_SIDE_MARGIN, screenRect.GetBottom() - MENU_SPACE - _fontHeight,
                                    MENU_BUTTON_WIDTH1, _fontHeight+4);
                                    _buttonOk = ::new SFRButtonControl(this, rect, "͂");

                                    // uv{^쐬
                                    SInt16 MENU_BUTTON_WIDTH2 = SFXGraphics::MeasureSingleText(AEE_FONT_NORMAL, "") +10;
                                    rect.Set(MENU_SIDE_MARGIN, screenRect.GetBottom() - MENU_SPACE - _fontHeight,
                                    MENU_BUTTON_WIDTH2, _fontHeight+4);
                                    rect.AddX(MENU_SPACE + MENU_BUTTON_WIDTH1);
                                    _buttonCancel = ::new SFRButtonControl(this, rect, "");

                                    if (static_try()) {
                                        // ZNgL[ftHgnhŏ (eLXgRg[̂)
                                        static_throw(RegisterHandler(SFEVT_KEY, AVK_SELECT,
                                        HANDLER_AFTER, HANDLER_FUNCTION(SelectHandler)));
                                        if (static_try()) {
                                            if (_textHour != null && _textMinute != null && _textContent != null) {
                                                // ő厚ݒ
                                                _textHour->SetMaxSize(2);
                                                _textMinute->SetMaxSize(2);
                                                _textContent->SetMaxSize(255);
                                                // tH[JXĂ
                                                _textHour->SetStatusFocus(true);
                                                if (static_try()) {
                                                    if (_buttonOk != null) {
                                                        // {^nh̓o^
                                                        static_throw(_buttonOk->RegisterHandler(SREVT_CONTROL,
                                                        HANDLER_BEFORE,HANDLER_FUNCTION(OnOkButtonControl)));
                                                        if (static_try()) {
                                                            if (_buttonCancel != null) {
                                                                // {^nh̓o^
                                                                static_throw(_buttonCancel->RegisterHandler(
                                                                SREVT_CONTROL, HANDLER_BEFORE,
                                                                HANDLER_FUNCTION(OnCancelButtonControl)));
                                                            }
                                                            else {
                                                                static_throw(SFERR_NO_MEMORY);
                                                            }
                                                        }
                                                    }
                                                    else {
                                                        static_throw(SFERR_NO_MEMORY);
                                                    }
                                                }
                                            }
                                            else {
                                                static_throw(SFERR_NO_MEMORY);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    return;
}


// fXgN^iEBhEjɎsj
DataInputWindow::~DataInputWindow(Void)
{
    SoftkeyWindow::Terminate(this);
    return;
}


// `nhiEBhEɕ`j
HANDLER_IMPLEMENT_VOIDRENDER(DataInputWindow, OnRenderContent, graphics)
{
    SFRPlainWindow::ContentHandler(graphics);
    return;
}


// L[ nhiEBhEOʂɂƂɃL[Ǝsj
HANDLER_IMPLEMENT_BOOLEVENT(DataInputWindow, OnKey, event)
{
    Bool result(false);

    switch (event.GetP16()) {
    case AVK_CLR:   // NA[ L[
        if (_textHour->GetStatusTarget() || _textMinute->GetStatusTarget() || _textContent->GetStatusTarget()) {
            _textHour->SetStatusTarget(false);
            _textMinute->SetStatusTarget(false);
            _textContent->SetStatusTarget(false);
            FocusNext();
            result = true;
        }
        else {
            // EBhE
            result = Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
        }
        break;
    case AVK_UP:
        FocusUp();
        result = true;
        break;
    case AVK_LEFT:
        FocusLeft();
        result = true;
        break;
    case AVK_DOWN:
        FocusDown();
        result = true;
        break;
    case AVK_RIGHT:
        FocusRight();
        result = true;
        break;
    }
    return result;
}


// {^nh
HANDLER_IMPLEMENT_VOIDCONTROL(DataInputWindow, OnOkButtonControl, result, control)
{
    unused(control);
    unused(result);
    SFXDate start(_date);

    // eLXgRg[當擾Đlɕϊ
    SInt16 hour = static_cast<SInt16>(_textHour->GetText().AsSInt32());
    if (hour < 0 || hour >= 24) {    // ͈̓`FbN
        hour = 0;
    }
    start.SetHour(hour);

    // eLXgRg[當擾Đlɕϊ
    SInt16 minute = static_cast<SInt16>(_textMinute->GetText().AsSInt32());
    if (minute < 0 || minute >= 60) {    // ͈̓`FbN
        minute = 0;
    }
    start.SetMinute(minute);
    // b0ɐݒ
    start.SetSecond(0);

    // e̓eLXgRg[當擾
    SFXAnsiString summary(static_cast<SFXAnsiString>(_textContent->GetText()));

    // f[^쐬(EBhE̎ނɂĈقȂ鏈)
    MakeData(start, summary);

    // ̃EBhE擾(OneDayWindow)
    SFRResponderPtr oneDayWindow = GetNext();

    // ݂̃EBhE
    Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
    oneDayWindow->InvalidateContent();
    result = true;
    return;
}


// {^nh
HANDLER_IMPLEMENT_VOIDCONTROL(DataInputWindow, OnCancelButtonControl, result, control)
{
    unused(control);
    unused(result);
    // ݂̃EBhE
    Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
    return;
}


CreateWindow::CreateWindow(SFXDateConstRef date) : DataInputWindow(date)
{
    return;
}


Void CreateWindow::MakeData(SFXDateConstRef start, SFXAnsiStringConstRef summary)
{
    VCalendarFilePtr vcal = ::new VCalendarFile("1.0", start, start, summary);
    if (vcal != null) {
        syncscheduler::GetVCalCollection()->Append(vcal);
    }
    return;
}


ModifyWindow::ModifyWindow(SFXDateConstRef date, VCalendarFilePtr vcal)
: DataInputWindow(date), // eRXgN^Ăяo
_vcal(vcal) // ύXf[^
{
    SFXDate start = _vcal->GetStartDate();
    // eLXgRg[̏lɎԂݒ
    _textHour->SetText(SFXWideString::Format("%d", start.GetHour()));
    // eLXgRg[̏lɕݒ
    _textMinute->SetText(SFXWideString::Format("%02d", start.GetMinute()));
    // eLXgRg[̏lɓeݒ
    _textContent->SetText(_vcal->GetSummary());
    return;
}


Void ModifyWindow::MakeData(SFXDateConstRef start, SFXAnsiStringConstRef summary)
{
    if (_vcal != null) {
        _vcal->Set(start, start, start ,summary);
        syncscheduler::GetVCalCollection()->Update(_vcal);
    }
    return;
}


// ͊AIɎ̑ΏۂɃtH[JX
HANDLER_IMPLEMENT_VOIDCONTROL(DataInputWindow, OnEditboxHandler, result, control)
{
    control->SetStatusTarget(false);
    if (result) {
        next = control->GetNext(TYPE_WILDCARD, ATTRIBUTE_WILDCARD);
        if (next != null) {
            next->SetStatusFocus(true);
        }
    }
    return;
}

