#include "MainWindow.hpp"
#include "syncscheduler.brh"
#include "syncscheduler.hpp"
#include "SoftkeyWindow.hpp"
#include "PreferenceDialog.hpp"
#include "VersionDialog.hpp"
#include "OneDayWindow.hpp"

#define     LABEL_SOFTKEY1          ("I")
#define     LABEL_SOFTKEY2          ("ƭ")
#define     LABEL_SOFTKEY3          ("I")
#define     MULTIDIALOG_HEIGHT      (136)
#define     CAL_TOP_MARGIN          (25)
#define     CAL_SIDE_MARGIN         (20)
#define     MAXLINE_TO_SHOW         (2)

enum {
    OPERATION_PREFERENCE,
    OPERATION_VERSION,
    OPERATION_LIMIT
};

MainWindow::MainWindow(SFRApplicationPtr director) static_throws : SFRPlainWindow(director, SFXRectangle(0, 0, 0, 0), BEHAVIOR_SFRPLAINWINDOW, ATTRIBUTE_MAINWINDOW)
{
    SoftkeyWindowPtr softkey;
    SoftkeyWindow::Initialize(this);
    if (static_try()) {
        //@`nho^
        static_throw(RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT, HANDLER_BEFORE, HANDLER_FUNCTION(OnRenderContent)));
        if (static_try()) {
            // L[nho^
            static_throw(RegisterHandler(SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
        }
    }
    if (static_try()) {
        static_throw(RegisterHandler(static_cast<SFCEventEnum>(SoftkeyWindow::USEREVT_SOFTKEY), HANDLER_AFTER, HANDLER_FUNCTION(OnSoftkey)));
        if (static_try()) {
            SetBaseBound(syncscheduler::CalculateWindowPosition());
            if ((softkey = SoftkeyWindow::GetInstance()) != null) {
                static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_1, LABEL_SOFTKEY1));
                if (static_try()) {
                    static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_2, LABEL_SOFTKEY2));
                    if (static_try()) {
                        static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_3, LABEL_SOFTKEY3));
                        if (static_try()) {
                            SetReference(softkey->Bind(this));
                           // J_[̂P}X̐`̒
                            _boxSizeX = (GetContentWorld().GetRight() - 2 * CAL_SIDE_MARGIN) / 7;
                            _boxSizeY = _boxSizeX - 3;
                            // J_[̍[
                            _calLeft = (GetContentWorld().GetRight() - 7 * _boxSizeX) / 2;
                            // ݂̓t擾
                            _cursor = SFXDate::CurrentDate();
                            _showcursor=1;
                        }
                    }
                }
            }
        }
    }
    return;
}


MainWindow::~MainWindow(Void)
{
    SoftkeyWindow::Terminate(this);
    return;
}


// `nhiEBhEɕ`j
HANDLER_IMPLEMENT_VOIDRENDER(MainWindow, OnRenderContent, graphics)
{
    //ݒ擾
    SFXConfigPtr option = syncscheduler::GetOption();

   // ʃTCY擾iSFXRectanglej
    SFXRectangle screenRect(GetContentWorld());

    // J[\̈ʒu擾
    SInt16 year = _cursor.GetYear();
    SInt16 month = _cursor.GetMonth();
    SInt16 day = _cursor.GetDay();

    // ݂̓t擾
    SFXDate current = SFXDate::CurrentDate();
    SFXAnsiString monthlong;
    SFXAnsiString daylong;
    SFXAnsiString dateString;

    switch (month) {
    case 1:
        monthlong = "January";
        break;
    case 2:
        monthlong = "February";
        break;
    case 3:
        monthlong = "March";
        break;
    case 4:
        monthlong = "April";
        break;
    case 5:
        monthlong = "May";
        break;
    case 6:
        monthlong = "June";
        break;
    case 7:
        monthlong = "July";
        break;
    case 8:
        monthlong = "August";
        break;
    case 9:
        monthlong = "September";
        break;
    case 10:
        monthlong = "October";
        break;
    case 11:
        monthlong = "November";
        break;
    case 12:
        monthlong = "Decenber";
        break;
    default:
        monthlong = "Error";
        break;
    }
    daylong= SFXAnsiString::Format("%d",day);
    switch (day%10) {
    case 1:
        if (day == 11) {
            daylong = daylong + "th";
        }
        else {
            daylong = daylong + "st";
        }
        break;
    case 2:
        if (day == 12) {
            daylong = daylong + "th";
        }
        else {
            daylong = daylong + "nd";
        }
        break;
    case 3:
        if (day == 13) {
            daylong = daylong + "th";
        }
        else {
            daylong = daylong + "rd";
        }
        break;
    default:
        daylong = daylong+"th";
        break;
    }
    Bool longDateDisplay=option->ReadBool(OPTION_LONGDATE, false);
    Bool mdyStyle=option->ReadBool(OPTION_MDY, false);
    if ( mdyStyle ) {
        if (longDateDisplay) {
            dateString = SFXAnsiString::Format("%s %s, %2d", monthlong.GetCString(),daylong.GetCString(),year);
        }
        else {
            dateString = SFXAnsiString::Format("%2d%2d %2dN", month,day,year);
        }
    }
    else {
        if ( longDateDisplay ) {
            dateString = SFXAnsiString::Format("%2d, %s %s", year,monthlong.GetCString() ,daylong.GetCString());
        }
        else {
            dateString= SFXAnsiString::Format("%2dN %2d%2d",year, month,day);
        }
    }
    //  // screenRectiȂ킿ʑŚj𔒂œhԂ
    graphics->FillRectangle(screenRect, SFXRGBColor(0xff, 0xff, 0xff, 0x00));

    // J_[̘g`悷
    DrawCalendarLine(screenRect, graphics);

    // 㕔ɔN`悷
    graphics->DrawSingleText( dateString, SFXGrid(CAL_SIDE_MARGIN, 0));
    // J_[̗j`悷
    DrawDayOfWeek(screenRect, graphics);
    // J_[̓t`悷
    DrawDate(current, screenRect, graphics);

    // \肪݂Ȃ牺ɂ̗\`
    if (syncscheduler::GetVCalCollection()->IsDataExist(year, month, day)) {
        DrawContent(screenRect, graphics);
    }
    return;
}


// J_[̘g`悷
Void MainWindow::DrawCalendarLine(SFXRectangleConstRef /*screenRect*/, SFXGraphicsPtr graphics)
{
    // 
    SFXLine varLine;
    // 
    SFXLine holLine;
    SInt16 i;
    graphics->SetForeColor(SFXRGBColor(0, 0, 0, 0));
    varLine.Set(_calLeft, CAL_TOP_MARGIN, _calLeft, CAL_TOP_MARGIN + 7 * _boxSizeY);
    holLine.Set(_calLeft, CAL_TOP_MARGIN, _calLeft + 7 * _boxSizeX, CAL_TOP_MARGIN);
    // `悷
    for (i = 1; i <= 8 ; ++i) {
        graphics->DrawLine(varLine);
        // _ boxSizeX EɈړ
        varLine.Offset(_boxSizeX, 0);
    }
    // `
    for (i = 1; i <= 8 ; ++i) {
        graphics->DrawLine(holLine);
        // _ boxSizeY Ɉړ
        holLine.Offset(0, _boxSizeY);
    }
}


// J_[̗j`悷
Void MainWindow::DrawDayOfWeek(SFXRectangleConstRef /*screenRect*/, SFXGraphicsPtr graphics)
{
    SFXRectangle calRect;
    static ACharConst youbi[][3] =
    {
        "", "", "", "", "", "", "y"
    };
    SInt16 i;

    calRect.Set(_calLeft + 1, CAL_TOP_MARGIN + 1, _boxSizeX - 1, _boxSizeY - 1);
   // j`悵Ă
    for (i = 1 ; i <= 7 ; ++i) {
        // ƓyjAj̐Fݒ肷
        if ( i==1 || i==7) {
            _DayBackGroundColor=SFXRGBColor(69, 105, 250,0);
        }
        else {
            _DayBackGroundColor=SFXRGBColor(150, 255, 125, 0);
        }
        graphics->FillRectangle(calRect, _DayBackGroundColor );
        graphics->SetForeColor(SFXRGBColor(0, 0, 0, 0));
        graphics->DrawSingleText(youbi[i - 1], calRect);
        calRect.AddX(_boxSizeX);    // lp`Eɓ
    }
}


// J_[̓t`悷
Void MainWindow::DrawDate(SFXDateConstRef current, SFXRectangleConstRef /*screenRect*/, SFXGraphicsPtr graphics)
{
    SFXRectangle calRect;
    SFXDate tempDate;
    SInt16 i;

    // ̌̂Pij̗j擾
    tempDate.Set(_cursor);
    tempDate.SetDay(1);
    SInt16 dayOfWeek = (tempDate.GetDayOfWeek() + 1) % 7;

    // lp`Qsڂ̂P̈ʒuɈړ
    calRect.Set(_calLeft + 1, CAL_TOP_MARGIN + _boxSizeY +1, _boxSizeX - 1, _boxSizeY - 1);
    calRect.AddX(_boxSizeX * dayOfWeek);

    // J[\ʒu̔N擾
    SInt16 year = _cursor.GetYear();
    SInt16 month = _cursor.GetMonth();
    SInt16 day = _cursor.GetDay();

    // ̂RsŁAyearNmonth̍Ō̓t擾
    tempDate.Set(year, month + 1, 1);
    tempDate.SubDay(1);
    SInt32 endDay = tempDate.GetDay();

    // 1炻̌̍Ō̓܂ŐȂǂ`悵Ă
    for (i = 1; i <= endDay; ++i) {
        // AyjƓj̐Fݒ肷
        if (dayOfWeek==0 || dayOfWeek==6) {
            _DayBackGroundColor=SFXRGBColor(193, 205, 253, 0);
            graphics->FillRectangle(calRect, _DayBackGroundColor);
        }
        else{
            _DayBackGroundColor=SFXRGBColor(210, 255, 172, 0);
            graphics->FillRectangle(calRect, _DayBackGroundColor);
        }

        // ̓Ȃ
        if (current.GetYear() == year
        && current.GetMonth() == month
        && current.GetDay() == i) {
            // \F`
            _DayBackGroundColor=SFXRGBColor(255, 204, 0, 0);
            graphics->FillRectangle(calRect, _DayBackGroundColor);
        }

        // ̓J[\̍tƈvȂ
        if (day == i) {
            // J[\`悷
            graphics->FillBevel(calRect, SFXBevelColor(SFXRGBColor (255, 30, 30, 0),_DayBackGroundColor,SFXRGBColor (255, 0, 0, 0)   ),true,true,true,true);
        }

        // ɗ\肪Ȃ_ł
        if (syncscheduler::GetVCalCollection()->IsDataExist(year, month, i)) {
            SFXRectangle pRect(calRect.GetLeft() + 2, calRect.GetTop() + 2, 3, 3);
            graphics->FillRectangle(pRect, SFXRGBColor(255, 0, 0, 0));
        }

        // `
        graphics->DrawSingleText(SFXAnsiString::Format("%2d",i), calRect, SFXRGBColor(0, 0, 0, 0));
        // T܂œB
        if (dayOfWeek == 6) {
            dayOfWeek = 0;
            calRect.SubX(_boxSizeX * 6);     // lp`ԍɈړ
            calRect.AddY(_boxSizeY);         // lp`}XɈړ
        }
        else {
            ++dayOfWeek;
            calRect.AddX(_boxSizeX);         //lp`P}XEɈړ
        }
    }
    return;
}


// J_[̗\蕔`悷
Void MainWindow::DrawContent(SFXRectangleConstRef screenRect, SFXGraphicsPtr graphics)
{
    VCalCollectionPtr vcalCollection = syncscheduler::GetVCalCollection();
    SFXRectangle calRect;

    calRect.Set(screenRect);
    calRect.AddTop(screenRect.GetBottom() - 40);
    SInt32 todayIndex = vcalCollection->GetIndex(
    _cursor.GetYear(), _cursor.GetMonth(), _cursor.GetDay());
    SInt32 todaySize =
    vcalCollection->GetNumberOfVCal(
    todayIndex, _cursor.GetYear(), _cursor.GetMonth(), _cursor.GetDay());
    calRect.AddTop(- 50);

    _totalshow = todaySize-1;

    // \蕔̎Op`̃J[\`
    SFXTriangle arrowup( screenRect.GetRight() /2 ,screenRect.GetBottom() -65,
                         screenRect.GetRight() /2 -8,screenRect.GetBottom() -65 +5,
                         screenRect.GetRight() /2 +8,screenRect.GetBottom() -65 +5 );
    SFXTriangle arrowdown( screenRect.GetRight() /2 ,screenRect.GetBottom() -5,
                         screenRect.GetRight() /2 -8,screenRect.GetBottom() -5 -5,
                         screenRect.GetRight() /2 +8,screenRect.GetBottom() -5 -5 );
    if (_showcursor == 1) {
        graphics->FillTriangle(arrowup,SFXRGBColor (100, 100, 100, 0));
    }
    else {
        graphics->FillTriangle(arrowup,SFXRGBColor (255, 30, 30, 0));
    }
        if (_showcursor == _totalshow) {
        graphics->FillTriangle(arrowdown,SFXRGBColor (100, 100, 100, 0));
    }
    else {
        graphics->FillTriangle(arrowdown,SFXRGBColor (255, 30, 30, 0));
    }

    // \ꗗ\
    SFXList<VCalendarFilePtr>::Enumerator e = vcalCollection->GetEnumerator(todayIndex);
    VCalendarPtr vcal;
    for (int i = 0; i<todaySize; i++) {
        vcal = e.GetNext();
        int item = i +1;
        SFXAnsiString bottomString = SFXAnsiString::Format("%d  %d/ ",item,todaySize);
        bottomString += SFXAnsiString::Format("%02d:%02d ", vcal->GetStartDate().GetHour(), vcal->GetStartDate().GetMinute());
        bottomString += vcal->GetSummary();
        if (i >=  (_showcursor-1) && i <=(_showcursor +MAXLINE_TO_SHOW -2) ) {
        graphics->DrawSingleText(bottomString, calRect,SFXRGBColor (0, 0, 0, 0), IDF_ALIGN_LEFT);
        calRect.AddTop(+ 40);
        }
    }
    return;
}


// L[nhiEBhEOʂɂƂɃL[Ǝsj
HANDLER_IMPLEMENT_BOOLEVENT(MainWindow, OnKey, event)
{
    Bool result(false);
    switch (event.GetP16()) {
    case AVK_SELECT:  // ZNgL[ꂽ
        ::new OneDayWindow(_cursor);
        result = true;
        break;
    case AVK_LEFT:
        _cursor.SubDay(1);      // J[\Ɉړ(1)
        InvalidateContent();    // ŕ`
        _showcursor=1;
        result = true;
        break;
    case AVK_RIGHT:
        _cursor.AddDay(1);      // J[\EɈړ(1)
        InvalidateContent();    // ŕ`
        _showcursor=1;
        result = true;
        break;
    case AVK_UP:
        _cursor.SubDay(7);      // J[\Ɉړ(1TԈ)
        InvalidateContent();    // ŕ`
        _showcursor=1;
        result = true;
        break;
    case AVK_DOWN:
        _cursor.AddDay(7);      // J[\Ɉړ(1Tԉ)
        InvalidateContent();    // ŕ`
        _showcursor=1;
        result = true;
        break;
    case AVK_2:
        if (_showcursor>1) {
            _showcursor--;      // \ɃXN[
        }
        InvalidateContent();
         result = true;
        break;
    case AVK_8:
        if (_showcursor + MAXLINE_TO_SHOW - 1  <= _totalshow) {
            _showcursor++;      // \ɃXN[
        }
        InvalidateContent();
        result = true;
        break;
    }
    return result;
}


HANDLER_IMPLEMENT_VOIDEVENT(MainWindow, OnSoftkey, event)
{
    SFRMultiDialogPtr dialog;
    SFRMultiDialog::ParamRec param;
    SFRTextMenuPtr menu;
    SFCError error(SFERR_NO_ERROR);

    switch (event.GetP16()) {
    case SoftkeyWindow::SOFTKEY_1:
        param.text = "IĂ낵ł?";
        param.ok = "͂";
        param.cancel = "";
        param.focus = SFRMultiDialog::FOCUS_CANCEL;
        param.image = SFBShell::GetInstance()->LoadResImage(SYNCSCHEDULER_RES_FILE, ACCEPT);
        if ((dialog = ::new SFRMultiDialog(syncscheduler::CalculateDialogPosition(SFRMultiDialog::GetMargin(), MULTIDIALOG_HEIGHT), "mF", param)) != null) {
            syncscheduler::OpenStandardDialog(dialog, HANDLER_FUNCTION(FromSoftkey1));
        }
        break;
    case SoftkeyWindow::SOFTKEY_2:
        if ((menu = ::new SFRTextMenu(syncscheduler::CalculateMenuPosition(OPERATION_LIMIT), "j[", null, 0)) != null) {
            if ((error = menu->static_catch()) == SFERR_NO_ERROR) {
                if ((error = menu->AppendItem("ݒ", AVK_1, 0xFBF6)) == SFERR_NO_ERROR) {
                    if ((error = menu->AppendItem("o[W", AVK_UNDEFINED)) == SFERR_NO_ERROR) {
                        error = syncscheduler::OpenStandardMenu(menu, HANDLER_FUNCTION(FromSoftkey2));
                    }
                }
            }
            if (error != SFERR_NO_ERROR) {
                ::delete menu;
            }
        }
        break;
    }
    return;
}


HANDLER_IMPLEMENT_VOIDDIALOG(MainWindow, FromSoftkey1, result, dialog)
{
    switch (result) {
    case SRP16_OK:
        syncscheduler::CloseStandardDialog(dialog);
        SFRApplication::Terminate();
        break;
    case SRP16_ESCAPE:
    case SRP16_CANCEL:
        syncscheduler::CloseStandardDialog(dialog);
        break;
    }
    return;
}


HANDLER_IMPLEMENT_VOIDMENU(MainWindow, FromSoftkey2, result, menu)
{
    SFRDialogPtr dialog;
    switch (result) {
    case OPERATION_PREFERENCE:
        syncscheduler::CloseStandardMenu(menu);
        if ((dialog = ::new PreferenceDialog) != null) {
            syncscheduler::OpenCustomDialog(dialog, HANDLER_FUNCTION(FromPreference));
        }
        break;
    case OPERATION_VERSION:
        syncscheduler::CloseStandardMenu(menu);
        if ((dialog = ::new VersionDialog) != null) {
            syncscheduler::OpenCustomDialog(dialog, HANDLER_FUNCTION(FromVersion));
        }
        break;
    case SRP16_ESCAPE:
    case SRP16_CANCEL:
        syncscheduler::CloseStandardMenu(menu);
        break;
    }
    return;
}


HANDLER_IMPLEMENT_VOIDDIALOG(MainWindow, FromPreference, result, dialog)
{
    switch (result) {
    case SRP16_OK:
        syncscheduler::CloseCustomDialog(dialog);
        // TODO
        break;
    case SRP16_ESCAPE:
    case SRP16_CANCEL:
        syncscheduler::CloseCustomDialog(dialog);
        break;
    }
    return;
}


HANDLER_IMPLEMENT_VOIDDIALOG(MainWindow, FromVersion, result, dialog)
{
    switch (result) {
    case SRP16_OK:
        syncscheduler::CloseCustomDialog(dialog);
        break;
    }
    return;
}

