#include "syncscheduler.hpp"
#include "OneDayWindow.hpp"
#include "DataInputWindow.hpp"
#include "SoftkeyWindow.hpp"
#include "MainWindow.hpp"
#include "syncscheduler.brh"

#define LABEL_SOFTKEY1          ("I")
#define LABEL_SOFTKEY2          ("폜")
#define LABEL_SOFTKEY3          ("I")
#define MENU_TOP_MARGIN    20
#define MENU_SIDE_MARGIN   20
#define MENU_CURSOR_WIDTH  10

OneDayWindow::OneDayWindow(SFXDateConstRef date) : SFRPlainWindow(SFRApplication::GetInstance(), syncscheduler::CalculateWindowPosition()), _date(date) static_throws
{
    SoftkeyWindowPtr softkey;
    // soft keyo^
    SoftkeyWindow::Initialize(this);
    if (static_try()) {
        // `nho^
        static_throw(RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT,
        HANDLER_BEFORE, HANDLER_FUNCTION(OnRenderContent)));
        if (static_try()) {
            // L[nho^
            static_throw(RegisterHandler(SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey)));
            if (static_try()) {
                //static_throw(RegisterHandler(static_cast<SFCEventEnum>(SoftkeyWindow::USEREVT_SOFTKEY), HANDLER_AFTER, HANDLER_FUNCTION(OnSoftkey)));
                if (static_try()) {
                    if ((softkey = SoftkeyWindow::GetInstance()) != null) {
                        static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_1, LABEL_SOFTKEY1));
                        if (static_try()) {
                            static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_2, LABEL_SOFTKEY2));
                            if (static_try()) {
                                static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_3, LABEL_SOFTKEY3));
                                if (static_try()) {
                                    SetReference(softkey->Bind(this));
                                    VCalCollectionPtr vcalCollection = syncscheduler::GetVCalCollection();
                                    _cursor = 0;
                                    _maxline = GetContentWorld().GetHeight() / SFXGraphics::GetFontHeight(AEE_FONT_NORMAL);
                                    _displine = 0;
                                    _index = vcalCollection->GetIndex(date.GetYear(), date.GetMonth(), date.GetDay());
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    return;
}


OneDayWindow::~OneDayWindow(Void)
{
    SoftkeyWindow::Terminate(this);
    return;
}


// `nhiEBhEɕ`j
HANDLER_IMPLEMENT_VOIDRENDER(OneDayWindow, OnRenderContent, graphics)
{
    //ʃTCY擾iSFXRectanglej
    SFXRectangle rect(graphics->GetDeviceRectangle());
    SFXAnsiString title;
    SIntN i;
    SInt32 offset;

    graphics->FillRectangle(rect, SFXRGBColor(255, 255, 255, 0));
    graphics->SetForeColor(SFXRGBColor(0, 0, 0, 0));
    rect.Deflate(MENU_SIDE_MARGIN, MENU_TOP_MARGIN);
    SInt16 height = graphics->GetFontHeight();
    rect.SetHeight(height);
    SInt32 line = 0;
    if (_displine == 0) {
        graphics->DrawSingleText("NEW", rect, IDF_ALIGN_LEFT);
        rect.AddY(height);
        ++line;
        offset = 0;
    }
    else {
        offset = _displine - 1;
    }
    SFXList<VCalendarFilePtr>::Enumerator e = syncscheduler::GetVCalCollection()->GetEnumerator(_index + offset);
    VCalCollectionPtr vcalCollection = syncscheduler::GetVCalCollection();
    _number = vcalCollection->GetNumberOfVCal(_index, _date.GetYear(), _date.GetMonth(), _date.GetDay());
    for (i = offset; i < _number && line <= _maxline; ++i) {
        VCalendarPtr vcal = e.GetNext();
        title = SFXAnsiString::Format("%02d:%02d ", vcal->GetStartDate().GetHour(),
        vcal->GetStartDate().GetMinute());
        title += vcal->GetSummary();
        graphics->DrawSingleText(title, rect, IDF_ALIGN_LEFT);
        rect.AddY(height);
        ++line;
    }
    // Op̃J[\
    SFXTriangle triangle(0, 0, 0, height, MENU_CURSOR_WIDTH, height / 2);
    triangle.Offset(MENU_SIDE_MARGIN - MENU_CURSOR_WIDTH, MENU_TOP_MARGIN);
    // J[\̈ʒu _cursor ŎsɈړ
    triangle.Offset(0, _cursor * height);
    // hԂF͔
    graphics->SetFillColor(SFXRGBColor(255, 255, 255, 0));
    graphics->DrawTriangle(triangle);
    return;
}


// L[nhiEBhEOʂɂƂɃL[Ǝsj
HANDLER_IMPLEMENT_BOOLEVENT(OneDayWindow, OnKey, event)
{
    Bool result(false);
    switch (event.GetP16()) {
    case AVK_CLR:       // NA[ L[ꂽA
        // EBhE
        result = Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE,SRP16_TERMINATE_INVOKE, true));
        break;
    case AVK_SOFT2:     // softkey 2 ꂽA
        // 쐬ꂽ̂ȂA_CAO\
        if (_cursor > 0) {
            SFRMultiDialog::ParamRec param;
            param.text = "̃XPW[폜Ă낵łH";
            param.ok = "͂";
            param.cancel = "";
            param.focus = SFRMultiDialog::FOCUS_CANCEL;
            param.image = SFBShell::GetInstance()->LoadResImage(SYNCSCHEDULER_RES_FILE, ACCEPT);
            if ((dialog = ::new SFRMultiDialog(syncscheduler::CalculateDialogPosition(SFRMultiDialog::GetMargin(), 130), "mF", param)) != null) {
                syncscheduler::OpenStandardDialog(dialog, HANDLER_FUNCTION(OnDelete));
            }
        }
        break;
    case AVK_SELECT:    // IL[ꂽA
        //VK쐬Ȃ
        if (_cursor <= 0) {
            // EBhE𐶐
            ::new CreateWindow(_date);
        }
        else {
            // J[\wĂf[^
            VCalendarFilePtr vcal =
            syncscheduler::GetVCalCollection()->Get(
            _index + _displine + _cursor - 1);
            // EBhE𐶐
            ::new ModifyWindow(_date, vcal);
        }
        result = true;
        break;
    case AVK_DOWN:      // L[ ꂽA
        // J[\f[^̈ԉɂȂȂ
        if (_cursor + _displine < _number) {
             // J[\ʂ̈ԉɂȂ
            if (_cursor >= _maxline - 1) {
                ++_displine; // \s
            }
            else {
                ++_cursor;  // J[\
            }
        }
        else {  // J[\ŉiȂ
            // J[\ŏi
            _displine = 0;
            _cursor = 0;
        }
        InvalidateContent(); // ĕ`
        result = true;
        break;
    case AVK_UP:    // L[ ꂽ
        // J[\ԏɂȂ
        if (_cursor == 0) {
            // \s֓Ȃ
            if (_displine > 0) {
                --_displine; // \s֓
            }
            else {  // J[\ŏiȂ
                 // J[\ŉi
                _cursor = (_number < _maxline - 1) ?
                static_cast<SInt16>(_number) : _maxline - 1;
                _displine = (_number > _maxline - 1) ?
                (static_cast<SInt16>(_number) - _maxline + 1) : 0;
            }
        }
        else {
            --_cursor;  // J[\
        }
        InvalidateContent(); // ĕ`
        result = true;
        break;
    case AVK_SOFT1:     // softkey1 ꂽA
        // Ĩ_CAO\
        #define     MULTIDIALOG_HEIGHT      (136)
        enum
        {
            OPERATION_PREFERENCE,
            OPERATION_VERSION,
            OPERATION_LIMIT
        };
        SFRMultiDialogPtr dialog;
        SFRMultiDialog::ParamRec param;

        param.text = "IĂ낵ł?";
        param.ok = "͂";
        param.cancel = "";
        param.focus = SFRMultiDialog::FOCUS_CANCEL;
        param.image = SFBShell::GetInstance()->LoadResImage(SYNCSCHEDULER_RES_FILE, ACCEPT);
        if ((dialog = ::new SFRMultiDialog(syncscheduler::CalculateDialogPosition(SFRMultiDialog::GetMargin(), MULTIDIALOG_HEIGHT), "mF", param)) != null) {
            syncscheduler::OpenStandardDialog(dialog, HANDLER_FUNCTION(FromSoftkey1));
        }
        break;
    }
    return result;
}


HANDLER_IMPLEMENT_VOIDDIALOG(OneDayWindow, FromSoftkey1, result, dialog)
{
    switch (result) {
    case SRP16_OK:
        syncscheduler::CloseStandardDialog(dialog);
        SFRApplication::Terminate();
        break;
    case SRP16_ESCAPE:
    case SRP16_CANCEL:
        syncscheduler::CloseStandardDialog(dialog);
        break;
    }
    return;
}


HANDLER_IMPLEMENT_VOIDDIALOG(OneDayWindow, OnDelete, result, dialog)
{
    VCalendarFilePtr vcal =  syncscheduler::GetVCalCollection()->Get(_index + _displine + _cursor -1);
    switch (result) {
    case SRP16_OK:
        // _CAOEBhE
        syncscheduler::CloseStandardDialog(dialog);
        InvalidateContent();
        // 폜
        syncscheduler::GetVCalCollection()->Remove(vcal);
        _cursor--;
        break;
    case SRP16_ESCAPE:
    case SRP16_CANCEL:
        syncscheduler::CloseStandardDialog(dialog);
        break;
    }

}

