#include "PreferenceDialog.hpp"
#include "syncscheduler.hpp"
#include "SoftkeyWindow.hpp"
#include "syncscheduler.brh"

#define     MARGIN                  (4)
#define     TOP_MARGIN              (1)
#if defined TARGET_COMPILER_ARMCPP
#define     PANEDATE_NAME           ("t\\")
#else
#define     PANEDATE_NAME           ("t\")
#endif
#define     LABEL_SOFTKEY1          ("I")
#define     LABEL_SOFTKEY2          ("߂")
#define     LABEL_SOFTKEY3          ("I")

PreferenceDialog::PreferenceDialog(Void) static_throws : SFRPlainDialog(SFXRectangle(0, 0, 0, 0), BEHAVIOR_SFRPLAINDIALOG, ATTRIBUTE_PREFERENCEDIALOG)
{
    SoftkeyWindowPtr softkey;
    SFRTabControlPtr tab(null);
    SFRTabPanePtr panedate(null);
    SFXRectangle rect;
    SFXConfigPtr option = syncscheduler::GetOption();
    SoftkeyWindow::Initialize(this);
    if (static_try()) {
        static_throw(RegisterHandler(static_cast<SFCEventEnum>(SoftkeyWindow::USEREVT_SOFTKEY), HANDLER_AFTER, HANDLER_FUNCTION(OnSoftkey)));
        if (static_try()) {
            SetBaseBound(syncscheduler::CalculateWindowPosition());
            rect = GetContentWorld();
            rect.AddTop(TOP_MARGIN);
            if ((tab = ::new SFRTabControl(this, rect)) != null) {
                static_throw(*tab);
                if (static_try()) {
                    if ((panedate = ::new SFRTabPane(tab, PANEDATE_NAME)) != null) {
                        static_throw(*panedate);
                        if (static_try()) {
                            Select();
                            if ((softkey = SoftkeyWindow::GetInstance()) != null) {
                                static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_1, LABEL_SOFTKEY1));
                                if (static_try()) {
                                    static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_2, LABEL_SOFTKEY2));
                                    if (static_try()) {
                                        static_throw(softkey->Register(this, SoftkeyWindow::SOFTKEY_3, LABEL_SOFTKEY3));
                                        if (static_try()) {
                                            SetReference(softkey->Bind(this));
                                        }
                                    }
                                }
                            }
                        }
                    }
                    else {
                        static_throw(SFERR_NO_MEMORY);
                    }
                }
            }
            else {
                static_throw(SFERR_NO_MEMORY);
            }
        }
    }
    SInt16 fontHeight = SFXGraphics::GetFontHeight(AEE_FONT_NORMAL);
    rect.Deflate(MARGIN, MARGIN);
    rect.SetHeight(fontHeight + MARGIN);
#if defined TARGET_COMPILER_ARMCPP
    ::new SFRLabelControl(panedate, rect, "t\\@:");
#else
    ::new SFRLabelControl(panedate, rect, "t\@:");
#endif
    rect.AddY(MARGIN + fontHeight);
    //œt\(Z)
#if defined TARGET_COMPILER_ARMCPP
    _radioNormaldate = ::new SFRRadiobuttonControl(panedate, rect,"ŕ\\");
#else
    _radioNormaldate = ::new SFRRadiobuttonControl(panedate, rect,"ŕ\");
#endif

    rect.AddY(MARGIN + fontHeight);
    //pœt\()
#if defined TARGET_COMPILER_ARMCPP
    _radioLongdate = ::new SFRRadiobuttonControl(panedate, rect,"pŕ\\");
#else
    _radioLongdate = ::new SFRRadiobuttonControl(panedate, rect,"pŕ\");
#endif
    _radioLongdate->Group(_radioNormaldate);
    if (option->ReadBool(OPTION_LONGDATE, false)) {
        _radioLongdate->SetStatusCheck(true);
    }
    else {
        _radioNormaldate->SetStatusCheck(true);
    }
    rect.AddY(MARGIN + fontHeight + 10);
    ::new SFRLabelControl(panedate, rect, "tX^C:");
    rect.AddY(MARGIN + fontHeight);
    //uN--vX^Cœt\
    _radioYMD = ::new SFRRadiobuttonControl(panedate, rect,"N--(YY-MM-DD)");
    rect.AddY(MARGIN + fontHeight);
    //u--NvX^Cœt\
    _radioMDY = ::new SFRRadiobuttonControl(panedate, rect,"--N(MM-DD-YY)");
    _radioMDY->Group(_radioYMD);
    if (option->ReadBool(OPTION_MDY, false)) {
        _radioMDY->SetStatusCheck(true);
    }
    else {
        _radioYMD->SetStatusCheck(true);
    }
    rect.AddY(MARGIN + fontHeight);
    rect.AddY(MARGIN + fontHeight);
    rect.SetWidth( (tab->GetContentWorld().GetWidth())/2 - 2*MARGIN);
    SFRButtonControlPtr buttonOk = ::new SFRButtonControl(panedate,rect, "");
    rect.AddX(rect.GetWidth() + MARGIN);
    SFRButtonControlPtr buttonCancel = ::new SFRButtonControl(panedate,rect, "LZ");
    if (static_try()) {
        static_throw(
        buttonOk->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControlOk)));
    }
    if (static_try()) {
        static_throw(
        buttonCancel->RegisterHandler(
        SREVT_CONTROL, HANDLER_BEFORE,
        HANDLER_FUNCTION(OnButtonControlCancel)));
    }
    return;
}


PreferenceDialog::~PreferenceDialog(Void)
{
    SoftkeyWindow::Terminate(this);
    return;
}


// option window OK {^̃nh
HANDLER_IMPLEMENT_VOIDCONTROL(PreferenceDialog, OnButtonControlOk, result, control)
{
    unused(result);
    unused(control);

    // ݒf[^ۑ
    SFXConfigPtr option = syncscheduler::GetOption();
    option->WriteBool(OPTION_LONGDATE,_radioLongdate->GetStatusCheck());
    option->WriteBool(OPTION_MDY,_radioMDY->GetStatusCheck());
    option->Save();
    // EBhE
    Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
}


HANDLER_IMPLEMENT_VOIDCONTROL(PreferenceDialog, OnButtonControlCancel, result, control)
{
    unused(result);
    unused(control);

    // EBhE
    Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
}


HANDLER_IMPLEMENT_VOIDEVENT(PreferenceDialog, OnSoftkey, event)
{
    switch (event.GetP16()) {
    case SoftkeyWindow::SOFTKEY_1:
        {
            #define     MULTIDIALOG_HEIGHT      (136)
            enum
            {
                OPERATION_PREFERENCE,
                OPERATION_VERSION,
                OPERATION_LIMIT
            };
            SFRMultiDialogPtr dialog;
            SFRMultiDialog::ParamRec param;

            param.text = "IĂ낵ł?";
            param.ok = "͂";
            param.cancel = "";
            param.focus = SFRMultiDialog::FOCUS_CANCEL;
            param.image = SFBShell::GetInstance()->LoadResImage(SYNCSCHEDULER_RES_FILE, ACCEPT);
            if ((dialog = ::new SFRMultiDialog(syncscheduler::CalculateDialogPosition(SFRMultiDialog::GetMargin(), MULTIDIALOG_HEIGHT), "mF", param)) != null) {
                syncscheduler::OpenStandardDialog(dialog, HANDLER_FUNCTION(FromSoftkey1));
            }
        }
        break;
    case SoftkeyWindow::SOFTKEY_2:
        Invoke(SFXEvent(SREVT_DIALOG, SRP16_OK, reinterpret_cast<UInt32>(this)));
        break;
    }
    return;
}


HANDLER_IMPLEMENT_VOIDDIALOG(PreferenceDialog, FromSoftkey1, result, dialog)
{
    switch (result) {
    case SRP16_OK:
        syncscheduler::CloseStandardDialog(dialog);
        SFRApplication::Terminate();
        break;
    case SRP16_ESCAPE:
    case SRP16_CANCEL:
        syncscheduler::CloseStandardDialog(dialog);
        break;
    }
    return;
}

