#ifndef __VCALENDAR_HPP
#define __VCALENDAR_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFCLASS(VCalendar)
SFMTYPEDEFCLASS(VCalendarFile)
SFMTYPEDEFCLASS(VCalCollection)

class VCalendar {
private:
    SFXAnsiString _version;
    SFXDate _startDate;
    SFXDate _endDate;
    SFXDate _lastModifiedDate;
    SFXAnsiString _summary;
    SFXAnsiString _others;
public:
    VCalendar(Void);
    VCalendar(SFXAnsiStringConstRef string);
    VCalendar(SFXAnsiStringConstRef version, SFXDateConstRef startDate,
        SFXDateConstRef endDate, SFXDateConstRef lastModifiedDate,
        SFXAnsiStringConstRef summary);
    Void Set(SFXDateConstRef startDate, SFXDateConstRef endDate,
        SFXDateConstRef lastModifiedDate, SFXAnsiStringConstRef summary);
    Void SetVersion(SFXAnsiStringConstRef version);
    SFXDate GetStartDate(Void) const;
    SFXDate GetEndDate(Void) const;
    SFXDate GetLastModifiedDate(Void) const;
    SFXAnsiString GetSummary(Void) const;
    Void Import(SFXAnsiStringConstRef string);
    Void Export(SFXAnsiStringPtr string) const;

    static SFXAnsiString PublishXid(SFXDateConstRef currentDT);
};


class VCalendarFile : public VCalendar {
private:
    SFXPath _fileName;            // t@C
    SFXAnsiString _flag;          // VK쐬Ȃ "n" ACȂ "m"A폜Ȃ "d"AȂȂ "-"
public:
    VCalendarFile(SFXPathConstRef fileName, SFXAnsiStringConstRef flag);
    VCalendarFile(SFXAnsiStringConstRef content,
        SFXPathConstRef fileName, SFXAnsiStringConstRef flag);
    VCalendarFile(SFXAnsiStringConstRef version, SFXDateConstRef startDate,
        SFXDateConstRef endDate, SFXAnsiStringConstRef summary);
    VCalendarFile();
    Void SetFileName(SFXPathConstRef fileName);
    Void SetFlag(SFXAnsiStringConstRef flag);
    SFXPath GetFileName(Void) const;
    SFXAnsiString GetFlag(Void) const;
    SFCError SaveToFile(Void) const;
    SFCError LoadFromFile(Void);
};


class VCalCollection {
private:
    // VCalendarFileǗB
    // ̃Xg͓ti_startDTjŏɃ\[gĂ̂Ƃ
    SFXList<VCalendarFilePtr> _list;
    SFXAnsiString _lastSyncTime;        // ŌɃT[oƓs
public:
    VCalCollection(Void);
    ~VCalCollection(Void);
    Void SetLastSyncTime(SFXAnsiStringConstRef lastSyncTime);
    SFXAnsiString GetLastSyncTime(Void) const;
    Void Append(VCalendarFilePtr vcalendar);
    Void Update(VCalendarFilePtr vcal);
    Void Delete(VCalendarFilePtr vcal);
    Void Remove(VCalendarFilePtr vcal);
    VCalendarFilePtr Get(SInt32 index) const;
    VCalendarFilePtr Get(SFXPathConstRef fileName) const;
    SFXList<VCalendarFilePtr>::Enumerator GetEnumerator(SInt32 index) const;
    SInt32 GetIndex(SInt16 year, SInt16 month, SInt16 day) const;
    SInt32 GetNumberOfVCal(SInt32 today, SInt16 year, SInt16 month, SInt16 day) const;
    Bool IsDataExist(SInt16 year, SInt16 month, SInt16 day) const;
    SFCError ReadIndexFile(Void);
    SFCError WriteIndexFile(Void);
    SFXAnsiString MakeListForSync(Void);
};

#endif // __VCALENDAR_HPP //
