#include "syncscheduler.hpp"
#include "SoftkeyWindow.hpp"
#include "MainWindow.hpp"

#define     INVALID_MEMORY_SIZE     (192000)
#define     DIALOG_MARGIN           (12)
#define     MENU_MARGIN             (2)
#define     LABEL_SOFTKEY2          ("")
#define     LABEL_SOFTKEY3          ("I")

//@u[g[_[
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
    // @ŗpꍇAŃCZX R[hݒ肵܂B

    *license = "heap://"

        "Y0TPT8RHWMYDUJZ6TKU1ROX8RBX2SBT3RPV1T0Y7XLW0KVNS8ROYFR4YOX7UET6U1DS4YLY7Y"
        "MVHR9SETPY4TQOMRMCSOROX9XLPU1WLRFNGUBT8XJU4Y7XPUARLXOS6VJS7U0XQRLV009Y7W2"
        "RLS5UKQVHYQTIR6W0SDPXGXMY9SPOT0VBRORNV2XAW1R9S34YNVHT1TAX9Z7UDDSDT3SLZCVE"
        "UD2X2Y9Z1WHVMXNX8GVASOYPRGZBEVERNTPW6WOTQY0VDFYO30Y8SIRAUMW1VEUPSIXBYMZ9U"
        "JWCVCTNZ0U8WBX9UIT7XET0XMYLV9YJ1LY4S7V3X8W6W6WBZ0YEXIXJZBVBYJRNWMVCR4/";

    return (id == AEECLSID_SYNCSCHEDULER) ? (&syncscheduler::Factory) : (null);
}

// t@Ng֐
SFCInvokerPtr syncscheduler::Factory(Void)
{
    SFCInvokerPtr result(null);

    #if TARGET_VERSION_GE(4, 0, 0)
    result = ::new syncscheduler;
    #else
    SFBHeapSmp heap;
    if ((heap = SFBHeap::NewInstance()) != null) {
        if (heap->CheckAvail(INVALID_MEMORY_SIZE)) {
            result = ::new syncscheduler;
        }
    }
    #endif
    return result;
}

// RXgN^
syncscheduler::syncscheduler(Void) static_throws
{
    SFRWindowPtr window;

    // Ŋenh̓o^s܂B

    if (static_try()) {

        // NAL[ŃAvIȂ悤ɁAׂẴNAL[CxgubN

        #if TARGET_VERSION_GE(3, 0, 0)
        static_throw(RegisterHandler(SFEVT_KEY, SFEVT_KEY_RELEASE, AVK_CLR, HANDLER_AFTER, HANDLER_NULL));
        #else
        static_throw(RegisterHandler(SFEVT_KEY, SFEVT_KEY_HELD, AVK_CLR, HANDLER_AFTER, HANDLER_NULL));
        #endif
        if (static_try()) {
            static_throw(RegisterHandler(SFEVT_APP_START, HANDLER_BEFORE, HANDLER_FUNCTION(OnAppStart)));
            if (static_try()) {
                static_throw(RegisterHandler(SFEVT_APP_STOP, HANDLER_AFTER, HANDLER_FUNCTION(OnAppStop)));
                if (static_try()) {
                    static_throw(RegisterHandler(SFEVT_APP_RESUME, HANDLER_BEFORE, HANDLER_FUNCTION(OnAppResume)));
                    if (static_try()) {
                        static_throw(RegisterHandler(SFEVT_APP_SUSPEND, HANDLER_AFTER, HANDLER_FUNCTION(OnAppSuspend)));
                        if (static_try()) {
                            if ((window = ::new SoftkeyWindow(this)) != null) {
                                static_throw(*window);
                                if (static_try()) {
                                     _option.Load(SFXPath("/calendar/option.dat"));
                                    if ((window = ::new MainWindow(this)) != null) {
                                        static_throw(*window);
                                        if (static_try()) {
                                            // t@Cf[^ǂݍ
                                            _vcalCollection.ReadIndexFile();
                                        }
                                    }
                                    else {
                                        static_throw(SFERR_NO_MEMORY);
                                    }
                                }
                            }
                            else {
                                static_throw(SFERR_NO_MEMORY);
                            }
                        }
                    }
                }
            }
        }
    }
    return;
}

// fXgN^
syncscheduler::~syncscheduler(Void)
{
    return;
}

// AvJnnh
HANDLER_IMPLEMENT_VOIDSTART(syncscheduler, OnAppStart, environment)
{
    // gpϐ̃[jO܂B

    unused(environment);

    // ɃAvJn̏Lq܂B

    return;
}

// AvInh
HANDLER_IMPLEMENT_VOIDSTOP(syncscheduler, OnAppStop, quitable)
{
    // gpϐ̃[jO܂B

    unused(quitable);

    // ɃAvȈLq܂B

    return;
}

// AvĊJnh
HANDLER_IMPLEMENT_VOIDRESUME(syncscheduler, OnAppResume, environment)
{
    // gpϐ̃[jO܂B

    unused(environment);

    // ɃAvĊJ̏Lq܂B

    return;
}

// Avfnh
HANDLER_IMPLEMENT_VOIDSUSPEND(syncscheduler, OnAppSuspend, reason, info)
{
    // gpϐ̃[jO܂B

    unused(reason);
    unused(info);

    // ɃAvf̏Lq܂B

    return;
}

SFXRectangle syncscheduler::CalculateWindowPosition(Void)
{
    SoftkeyWindowPtr softkey;
    SFXRectangle result(GetInstance()->GetContentWorld());

    if ((softkey = SoftkeyWindow::GetInstance()) != null) {
        result.SubBottom(softkey->GetBaseBound().GetHeight());
    }
    return result;
}

SFXRectangle syncscheduler::CalculateDialogPosition(SFXMarginConstRef margin, SInt16 height)
{
    SoftkeyWindowPtr softkey;
    SFXRectangle rect(GetInstance()->GetContentWorld());
    SFXRectangle result(0, 0, 0, 0);

    result.SetSize(rect.GetWidth() - DIALOG_MARGIN * 2 - margin.GetLeft() - margin.GetRight(), height);
    result.Offset(SFXGrid(rect.GetSize() - result.GetSize()) / 2);
    result.Inflate(margin);
    result.AddY(margin.GetTop() - margin.GetBottom());
    if ((softkey = SoftkeyWindow::GetInstance()) != null) {
        result.SubY(softkey->GetBaseBound().GetHeight());
    }
    return result;
}

SFXRectangle syncscheduler::CalculateMenuPosition(SInt16 limit)
{
    SoftkeyWindowPtr softkey;
    SFXRectangle rect(GetInstance()->GetContentWorld());
    SInt16 height;
    SFXRectangle result(0, 0, 0, 0);

    height = SFXGraphics::GetFontHeight(AEE_FONT_NORMAL) + MENU_MARGIN;
    if ((softkey = SoftkeyWindow::GetInstance()) != null) {
        rect.SubBottom(softkey->GetBaseBound().GetHeight());
    }
    result.SetSize(rect.GetWidth() * 3 / 4, height * limit);
    result.Inflate(SFRTextMenu::GetMargin());
    result.SetOrigin(0, 0);
    result.Offset(SFXGrid(rect.GetSize() - result.GetSize()));
    return result;
}

SFCError syncscheduler::OpenStandardDialog(SFRDialogPtr dialog, SFRHandlerSPP procedure, VoidPtr reference)
{
    SoftkeyWindowPtr softkey;
    SFCError error(SFERR_NO_ERROR);

    if ((error = dialog->static_catch()) == SFERR_NO_ERROR) {
        if ((error = dialog->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE, procedure, reference)) == SFERR_NO_ERROR) {
            SoftkeyWindow::Initialize(dialog);
            if ((softkey = SoftkeyWindow::GetInstance()) != null) {
                if ((error = softkey->Register(dialog, SoftkeyWindow::SOFTKEY_3, LABEL_SOFTKEY3)) == SFERR_NO_ERROR) {
                    dialog->SetReference(softkey->Bind(dialog));
                }
            }
        }
    }
    if (error != SFERR_NO_ERROR) {
        ::delete dialog;
    }
    return error;
}

Void syncscheduler::CloseStandardDialog(SFRDialogPtr dialog)
{
    SoftkeyWindow::Terminate(dialog);
    dialog->DialogHandler();
    return;
}

SFCError syncscheduler::OpenCustomDialog(SFRDialogPtr dialog, SFRHandlerSPP procedure, VoidPtr reference)
{
    SFCError error(SFERR_NO_ERROR);

    if ((error = dialog->static_catch()) == SFERR_NO_ERROR) {
        error = dialog->RegisterHandler(SREVT_DIALOG, HANDLER_BEFORE, procedure, reference);
    }
    if (error != SFERR_NO_ERROR) {
        ::delete dialog;
    }
    return error;
}

Void syncscheduler::CloseCustomDialog(SFRDialogPtr dialog)
{
    dialog->DialogHandler();
    return;
}

SFCError syncscheduler::OpenStandardMenu(SFRMenuPtr menu, SFRHandlerSPP procedure, VoidPtr reference)
{
    SoftkeyWindowPtr softkey;
    SFCError error(SFERR_NO_ERROR);

    if ((error = menu->static_catch()) == SFERR_NO_ERROR) {
        if ((error = menu->RegisterHandler(SREVT_MENU, HANDLER_BEFORE, procedure, reference)) == SFERR_NO_ERROR) {
            if ((error = menu->RegisterHandler(static_cast<SFCEventEnum>(SoftkeyWindow::USEREVT_SOFTKEY), HANDLER_AFTER, OnSoftkeySHP, menu)) == SFERR_NO_ERROR) {
                SoftkeyWindow::Initialize(menu);
                if ((softkey = SoftkeyWindow::GetInstance()) != null) {
                    if ((error = softkey->Register(menu, SoftkeyWindow::SOFTKEY_2, LABEL_SOFTKEY2)) == SFERR_NO_ERROR) {
                        if ((error = softkey->Register(menu, SoftkeyWindow::SOFTKEY_3, LABEL_SOFTKEY3)) == SFERR_NO_ERROR) {
                            menu->SetReference(softkey->Bind(menu));
                        }
                    }
                }
            }
        }
    }
    return error;
}

Void syncscheduler::CloseStandardMenu(SFRMenuPtr menu)
{
    SoftkeyWindow::Terminate(menu);
    menu->MenuHandler();
    return;
}

Bool syncscheduler::OnSoftkeySHP(SFXEventConstRef event, VoidPtr reference)
{
    SFRMenuPtr menu;

    switch (event.GetP16()) {
        case SoftkeyWindow::SOFTKEY_2:
            menu = static_cast<SFRMenuPtr>(reference);
            menu->Invoke(SFXEvent(SREVT_MENU, SRP16_CANCEL, reinterpret_cast<UInt32>(menu)));
            break;
    }
    return true;
}

// VCalCollection ̃CX^X擾
VCalCollectionPtr syncscheduler::GetVCalCollection(Void)
{
    return &static_cast<syncschedulerPtr>(GetInstance())->_vcalCollection;
}

// ݒ擾
SFXConfigPtr syncscheduler::GetOption(Void)
{
    return &(static_cast<syncschedulerPtr>(GetInstance())->_option);
}
